<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
|--------------------------------------------------------------------------
| File and Directory Modes
|--------------------------------------------------------------------------
|
| These prefs are used when checking and setting modes when working
| with the file system.  The defaults are fine on servers with proper
| security, but you may wish (or even need) to change the values in
| certain environments (Apache running a separate process for each
| user, PHP under CGI with Apache suEXEC, etc.).  Octal values should
| always be used to set the mode correctly.
|
*/
define('FILE_READ_MODE', 0644);
define('FILE_WRITE_MODE', 0666);
define('DIR_READ_MODE', 0755);
define('DIR_WRITE_MODE', 0777);

/*
|--------------------------------------------------------------------------
| File Stream Modes
|--------------------------------------------------------------------------
|
| These modes are used when working with fopen()/popen()
|
*/

define('FOPEN_READ',							'rb');
define('FOPEN_READ_WRITE',						'r+b');
define('FOPEN_WRITE_CREATE_DESTRUCTIVE',		'wb'); // truncates existing file data, use with care
define('FOPEN_READ_WRITE_CREATE_DESTRUCTIVE',	'w+b'); // truncates existing file data, use with care
define('FOPEN_WRITE_CREATE',					'ab');
define('FOPEN_READ_WRITE_CREATE',				'a+b');
define('FOPEN_WRITE_CREATE_STRICT',				'xb');
define('FOPEN_READ_WRITE_CREATE_STRICT',		'x+b');


/* 
|--------------------------------------------------------------------------
| Custome defined vars
|--------------------------------------------------------------------------
|
| 
|
 */

define('STAFF_FEED_URL',	'http://www.kindersigns.org/bizyoffice/index.php/');


switch (ENVIRONMENT){

	case "development":
		
		//roles
		define('ADMIN',286);
		define('DEVELOPER',287);
		
		//functions
		define('ADD_CONNECTION',574);
		define('EDIT_CONNECTION',575);
		define('DELETE_CONNECTION',576);
		define('VIEW_ACCESS_LOG',577);
		
		
		define('UAACS_MOOD',	true);
		define('UAACS_URL','http://uaacstest.kindersigns.org');
		define('CLIENT_FEED_URL',	'https://www.bizydads.com/MasterOrg/client_master/index.php/');
		break;
				
	case "testing":
		
		//roles
		define('ADMIN',286);
		define('DEVELOPER',287);
		
		//functions
		define('ADD_CONNECTION',574);
		define('EDIT_CONNECTION',575);
		define('DELETE_CONNECTION',576);
		define('VIEW_ACCESS_LOG',577);
		
		define('UAACS_MOOD',	true);
		define('UAACS_URL','http://uaacstest.kindersigns.org');
		define('CLIENT_FEED_URL',	'http://www.bizydads.com/MasterOrg/client_master/index.php/');
		break;
		
	case "qa":
		
		//roles
		define('ADMIN',286);
		define('DEVELOPER',287);
		
		//functions
		define('ADD_CONNECTION',574);
		define('EDIT_CONNECTION',575);
		define('DELETE_CONNECTION',576);
		define('VIEW_ACCESS_LOG',577);
		
		define('UAACS_MOOD',	true);
		define('UAACS_URL','http://uaacstest.kindersigns.org');
		define('CLIENT_FEED_URL',	'https://www.bizydads.com/MasterOrg/client_master/index.php/');
		break;
		
	case "production":
		
		//roles
		define('ADMIN',251);
		define('DEVELOPER',252);
		
		//functions
		define('ADD_CONNECTION',546);
		define('EDIT_CONNECTION',547);
		define('DELETE_CONNECTION',548);
		define('VIEW_ACCESS_LOG',552);
				
		define('UAACS_MOOD',	true);
		define('UAACS_URL','http://uaacs.kindersigns.org');
		define('CLIENT_FEED_URL',	'http://www.ekwa.com/MasterOrg/client_master/index.php/');
		break;
		
}//end of switch


/* End of file constants.php */
/* Location: ./application/config/constants.php */