<?php 
/**
 * Manually Developed CI Controller
 * 
 * @package			AIR\controllers\Home
 * @version			V1.2.0
 * @copyright		2015, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			MRM Roshan <roshan@ekwa.com>
 * 
 */
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
@session_start();
/**
 * Manually Developed CI Controller
 *
 * This controller facilitates the access of table countries
 *  
 * Usage:-
 *  
 *			function __construct(), default funtion to init uaacs vars  
 *
 * @package			AIR\controllers\Home
 * @version			V1.2.0
 * @copyright		2015, BizyCorp Internal Systems Development
 * @license			private, All rights reserved
 * @author			MRM Roshan
 * @created			July 2014  
 * @uses			
 * @see 
 * @modified        28/04/2016 by MRM Roshan		
 * @modification	1. Fix UAACS redirect issue when login to AIR
 */
class Home extends CI_Controller {
		
	/**
	 * Function  __construct ()
	 *
	 * @access public 
	 * @since 
	 * @modified           Jun 17, 2016 by Roshan Ruzaik <mrmroshan@yahoo.com>
	 * @modification  Fixed bug id 21881,20809,20483        
	 * @return void
	 */
	function __construct(){
		
		parent::__construct();		
		if (UAACS_MOOD) {
							
			$this->load->library('Uaacs_authentication');
			$mySession = session_id();
			
			if (isset($_POST['newrole'])){
				$_SESSION['newrole_'.$this->config->item('UAACS_APPID')] = $_POST['newrole'];
			} else if (!isset($_SESSION['newrole_'.$this->config->item('UAACS_APPID')])) {
				$_SESSION['newrole_'.$this->config->item('UAACS_APPID')]=
				isset($_COOKIE['defRoleId_'.$this->config->item('UAACS_APPID')])?
				$_COOKIE['defRoleId_'.$this->config->item('UAACS_APPID')]: 287 ; //set default to dev
				
			}
			$roleId = $_SESSION['newrole_'.$this->config->item('UAACS_APPID')];
			
			$uaacs = new Uaacs_authentication ;
			$uaacs->setLandingPage(site_url());
			$uaacs->setAccessKey($this->config->item('UAACS_ACCESS_KEY'));
			$uaacs->setSecurityKey($this->config->item('UAACS_SEC_KEY')) ;
			$uaacs->setAppId($this->config->item('UAACS_APPID')) ;
			$uaacs->setRoleId($roleId) ;
			
			//Following are optional
			$uaacs->setLogoutUrl($this->config->item('UAACS_LOGOUT_URL'));
			$uaacs->setLoginUrl($this->config->item('UAACS_LOGIN_URL'));
			$uaacs->setLgnCheckUrl($this->config->item('UAACS_LOGIN_CHECK_URL'));
			$uaacs->authenticate();
			//var_dump($uaacs);exit;
			$functions = $uaacs->getAllowedFunctions() ;  //An array
			$myRoles = $uaacs->getAllowedRoles();         //An array
			$roleId = $uaacs->getActiveRole();
			$data = $uaacs->getUserData();                //simpleXMLObject
			
			//@session_start();
			$_SESSION['functions_'.$this->config->item('UAACS_APPID')] = $functions ; //An array			
			$_SESSION['roles_'.$this->config->item('UAACS_APPID')] = $myRoles;        //An array
			$_SESSION['roleId_'.$this->config->item('UAACS_APPID')] = $roleId;			
			$_SESSION['user_id_'.$this->config->item('UAACS_APPID')] = (string) $data->DATALIST->USER->UID ;			
			$_SESSION['user_name'] = (string) $data->DATALIST->USER->NAME;
			
			//$_SESSION['datalist'] = $data->DATALIST;	
			
			$_SESSION["user_id"]=(string) $data->DATALIST->USER->UID;
			setcookie("user_id",(string) $data->DATALIST->USER->UID);
			$_SESSION["user_name"]=(string) $data->DATALIST->USER->NAME;
			setcookie("user_name",(string) $data->DATALIST->USER->NAME);
			$_SESSION["user_type"]=$myRoles[$roleId]['NAME'];
			setcookie("user_type",$myRoles[$roleId]['NAME']);
			
			$_SESSION["air_user_name"]=(string) $data->DATALIST->USER->NAME;
			setcookie("air_user_name",(string) $data->DATALIST->USER->NAME);
			$_SESSION["air_user_type"]=$myRoles[$roleId]['NAME'];
			setcookie("air_user_type",$myRoles[$roleId]['NAME']);
				
			
			$jason = $data->DATALIST;				
			$jason = json_encode($jason);
			$enc_jason = base64_encode($jason);
				
			$_SESSION['uaacs_data_jason'] =  $enc_jason;
			
			//Following added to save the default role
			if (!isset($_COOKIE['defRoleId_'.$this->config->item('UAACS_APPID')])) setcookie('defRoleId_'.$this->config->item('UAACS_APPID'),$_SESSION['roleId_'.$this->config->item('UAACS_APPID')],time()+604800,"/", "{$_SERVER['SERVER_NAME']}");
				
		}//end if
		
		$data = array();
		$data['msg'] = null;
		$this->load->view('home',$data);
		
	}
	
	
	/**
	 * index()
	 * 
	 * This is an empty function. 
	 * 
	 */
	public function index(){ }//end of function	
	
}//end of Home

/* End of file home.php */
/* Location: ./application/controllers/home.php */
?>