<?php
if ( ! function_exists('getHeadersList'))
{		
		/**
		 * getHeadersList() function
		 *
		 * Parses data array and return list of headers
		 *
		 * @param $one_record one record from data array
		 *
		 * @return comma separated list of headers
		 */

         function getHeadersList($one_record)
         {
			$out = array();
			$one_record=array_slice($one_record,1);
			foreach($one_record as $h)
			{
				$out[] = $h['header'];
			}
			
			 return join(',',$out);
         }
}

//------------------------------------------------------
// modified by WCD on 17/10/2014 to be replaced by above which support CSS styling
if ( ! function_exists('convertHTMLTable'))
{
	/**
	 * convertHTMLTable() function
	 *
	 * Prepares and echoes HTML table for jQuery datatables
	 *
	 * @param $data Data Array
	 *
	 * @return void
	 */
	function convertHTMLTable($data,$widths='',$colList = false, $styleSheet = false)
	{
		$widthArr = array();
		$dashBoardURL = array();
		if(is_array($widths)) $widthArr = $widths ;
		////////////////////////////////////////////////////
		$dataset = $data['dataset']['result_set'];


		$pk = explode(",",$data['dataset']['metadata']['PK']);
		//------------ Create headers -------------------
		//$headerList = getHeadersList($dataset['dataset']['metadata']);
		//$headers = explode(',',$headerList);
		$headers =array_slice($data['dataset']['metadata'],1);
		if ($styleSheet){
			$styleSheet = "\n".'<link rel="stylesheet" type="text/css" href="$styleSheet" media="screen">' ;
		}else{
			$styleSheet = "\n".'<link rel="stylesheet" type="text/css" href="'.base_url("public/css/html_gridview.css").'" media="screen">' ;
		}
		
		$tableHTML = "\n<table id='cigen_datatable' style='' class=''>\n\t~HEADERS~\n\t\n\t<tbody>~DATAROWS~\n\n\t</tbody>\n\t<tfoot><tr><td colspan='".(count($colList?$colList:$headers))."'></tr></tfoot>\n</table>";
		$headerHTML = '';
		$headerHTML .= "\n\t<colgroup>";
		foreach($headers as $key=>$h)     //Set col widths
		{
			if($h['width'] =="" || $h['width'] < "15"){
				$width="50";
			}else{
				$width=$h['width'];
			}

			if ($colList) {
				if (in_array($key,$colList) ) {
					if (sizeof($widthArr)>0) { //User specified column widths are active
						$width=$widthArr[$key];
					}
					$headerHTML .= "\n\t\t\t<col style='width:{$width}em;' >";
				}
			}else{
				$headerHTML .= "\n\t\t\t<col style='width:{$width}em;'>";
			}
		}
		$headerHTML .= "\n\t</colgroup>\n\t<thead>";
		$headerHTML .= "\n\t\t<tr class=\"headerrow\" >";
		foreach($headers as $key=>$h)
		{
			if ($colList) {
				if (in_array($key,$colList) ) {
					//$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
					$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
				}
			}else{
				//$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
				$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
			}
		}
		$headerHTML .= "\n\t\t</tr>\n\t</thead>";
		// ----------end of headers -----------------
		$nrows = sizeof($dataset) ;
		$datarowHTML = '';
		for($i=1;$i<=$nrows;$i++)
		{
		$datarowHTML .= "\n\t\t<tr class=\"dararow\" >\n";
          foreach($dataset[$i] as $key=>$v)
          {
          if(!(isset($v))) {
			$thisValue = '';
			} else {
				$thisValue = $v;
			}
			if ($colList){
				if(in_array($key,$colList) ){
				$datarowHTML .= "\n\t\t\t<td class=\"datacell\">".stripslashes($thisValue)."</td>";
				}
				}else {
				$datarowHTML .= "\n\t\t\t<td class=\"datacell\">".stripslashes($thisValue)."</td>\n";
				}
				}
				$datarowHTML .= "\n\t\t</tr>\n";
  			 }
  			 $out = str_replace('~HEADERS~',$headerHTML,(str_replace('~DATAROWS~',$datarowHTML,$tableHTML)));
  			 return $styleSheet.$out;
	}
	}

	//-----------------------------------------------------
/* Commented by WCD on 17/10/2014 to be replaced by above which support CSS styling
if ( ! function_exists('convertHTMLTable'))
{
	    /**
		 * convertHTMLTable() function
		 *
		 * Prepares and echoes HTML table for jQuery datatables
		 *
		 * @param $data Data Array
		 *
		 * @return void
		 *//*
	//replace convertHTMLTable function with Channa's web2call cigen convertHTMLTable function
	//modify by NCW
     function convertHTMLTable($data,$widths='',$colList = false)
     {
        $widthArr = array();
        $dashBoardURL = array();
        if(is_array($widths)) $widthArr = $widths ;
        ////////////////////////////////////////////////////
    	  $dataset = $data['dataset']['result_set'];
        
        
    	 $pk = explode(",",$data['dataset']['metadata']['PK']);
        //------------ Create headers -------------------
        //$headerList = getHeadersList($dataset['dataset']['metadata']);
        //$headers = explode(',',$headerList);
        $headers =array_slice($data['dataset']['metadata'],1);
        $styleSheet = "\n".'<link rel="stylesheet" type="text/css" href="'.base_url("application/views/html_gridview_css.php").'" media="screen">' ;
        $tableHTML = "\n<table id='cigen_datatable' style='' class=''>\n\t~HEADERS~\n\t\n\t<tbody>~DATAROWS~\n\n\t</tbody>\n\t<tfoot><tr><td colspan='".(count($colList?$colList:$headers))."'></tr></tfoot>\n</table>";
        $headerHTML = '';
        $headerHTML .= "\n\t<colgroup>";
        foreach($headers as $key=>$h)     //Set col widths
  			{
          if($h['width'] =="" || $h['width'] < "15"){
          	$width="50";              
          }else{
          	$width=$h['width'];              	
          }
          
          if ($colList) {            
            if (in_array($key,$colList) ) { 
              if (sizeof($widthArr)>0) { //User specified column widths are active
                $width=$widthArr[$key];
              }
              $headerHTML .= "\n\t\t\t<col style='width:{$width}em;' >";
            }
          }else{
            $headerHTML .= "\n\t\t\t<col style='width:{$width}em;'>";
          }
  			}
        $headerHTML .= "\n\t</colgroup>\n\t<thead>";
        $headerHTML .= "\n\t\t<tr class=\"headerrow\" >";
  			foreach($headers as $key=>$h)
  			{
          if ($colList) {
            if (in_array($key,$colList) ) {
              //$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
              $headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
            }
          }else{
            //$headerHTML .= "\n\t\t\t<th class=\"headercell\" style='width:{$h['width']}; text-align: center;'>{$h['header']}</th>";
            $headerHTML .= "\n\t\t\t<th class=\"headercell\" style='text-align: center;'>{$h['header']}</th>";
          }
  			}
        $headerHTML .= "\n\t\t</tr>\n\t</thead>";
        // ----------end of headers -----------------
  			$nrows = sizeof($dataset) ;
        $datarowHTML = '';
        for($i=1;$i<=$nrows;$i++)
        {
          $datarowHTML .= "\n\t\t<tr class=\"dararow\" >\n";
          foreach($dataset[$i] as $key=>$v)
          {   
            if(!(isset($v))) {
              $thisValue = '';
            } else {
              $thisValue = $v;
            }
            if ($colList){
              if(in_array($key,$colList) ){
                $datarowHTML .= "\n\t\t\t<td class=\"datacell\">".stripslashes($thisValue)."</td>";
              }
            }else {
              $datarowHTML .= "\n\t\t\t<td class=\"datacell\">".stripslashes($thisValue)."</td>\n";
            }
  				}
          $datarowHTML .= "\n\t\t</tr>\n";
  			 }
  			 $out = str_replace('~HEADERS~',$headerHTML,(str_replace('~DATAROWS~',$datarowHTML,$tableHTML)));
  			 return $styleSheet.$out;
      }
}
*/
if ( ! function_exists('getArrayElements'))
{
	/**
	 * getArrayElements() function
	 *
	 * Returns wanter array element, if exists
	 *
	 * @param $array , the array
	 *
	 * @param $key , key to be checked
	 *
	 * @return String, array element value if found, otherwise an empty string
	 */
	function getArrayElements($array,$key)
	{
		if(is_array($array))
		{
			if(array_key_exists($key,$array))
			{
				return $array[$key];
			}
			else
				return '';
		}
		else
			return '';
	}
}

	/**
	 * input() function
	 *
	 * Prepares and echoes HTML Code for Input feilds
	 *
	 * @param $data Data Array
	 *
	 * @param $pkval , Value of the primary key field of data record, to identity record
	 *
	 * @param $field, Name of database table field
	 *
	 * @param $type Optional, type of input tag, Default Text
	 *
	 * @return void
	 */
function input($data,$pkval,$field,$type="text")
{

	$dataset = $data['dataset']['result_set'];
    $pk = explode(",",$data['dataset']['metadata']['PK']);
	
	$nrows = sizeof($dataset) - 1;
	for($ix=1;$ix<=$nrows;$ix++)
	{
		if($ix > 0)
		{
			unset($pk_g);
			foreach($pk as $col){
				$pk_g[] = $dataset[$i][$col];
				 
			}
			$pk_grid=join("_",$pk_g);
			unset($pk_g);
			if($pk_grid == $pkval)
			{
				echo '<input type="'.$type.'" id="'.$field.$pkval.'" name="'.$field.$pkval.'" value="'.$dataset[$ix][$field] .'">';
			}
		}
		$pk_grid="";
		$ix++;
	}
}

	/**
	 * dropdown() function
	 *
	 * Prepares and echoes HTML/DHTMLX Code for Dropdown list
	 *
	 * @param $data - required - Data Array
	 * 
	 * @param $name - required - The name and the id of the dropdown controller.
	 * 
	 * @param $fieldName - required - The field name of the record set which is to be listed in options.
	 *
	 * @param $selectByText - optional - The option text(s) to be selected on load of the dropdown.  
	 *
	 * @param $selectByVal - optional -The option value(s) to be selected on load of the dropdown 
	 *
	 * @param $format - optional - The dropdown output format as html or xml
	 * 
	 * @param $multiple - optional - to specify either multiple select or single select option
	 * 
	 * @param $optionsOnly - optional - To specify to output only options list without select controller
	 * 
	 * @return void
	 * 
	 * Updates:
	 * 
	 * 1. Rearranged parameter list from required to optional  from left to right 
	 * 2. Removed unwanted parameters - $keyfield,$skipfield,$label
	 * 			
	 * Updated on 11/4/2013
	 * 
	 * By: MRoshan
	 * 
	 * 
	 *   $dataArray = array('data' => $data,
	 *   					'fieldName' => $fieldName,  (html name attrib)
	 *   					'label' => $label,
	 *   					'selectByText' => null,
	 *   					'selectByVal' => null,
	 *   					'format' => 'html',
	 *   					'multiple' => false,
	 *   					'optionsOnly' => false,
	 *   					'groupby'=>field to group by,
	 *   					'display' => field / column to display as value,
							'required' => true/false, a requrired field or not ,
							'codename' => group by codes to display instead of field value
	 *    );
	 * 
	 * //function dropdown($data, $name, $fieldName,$label, $selectByText=null, $selectByVal=null, $format='html', $multiple=false, $optionsOnly=false)
	
	 * */


function dropdown($dataArray)
{
	
	/* 
	 * following set of codes are common for both xml and html code segments. 
	 * 
	 * */
	
    	$dataset = $dataArray['data']['dataset']['result_set'];
        //var_dump($dataArray);
    	$pk = $dataArray['data']['dataset']['metadata']['PK'];
        $grp = isset($dataArray['data']['dataset']['metadata']['cmanager'])?$dataArray['data']['dataset']['metadata']['cmanager']:null;
		$fieldName = isset($dataArray['fieldName'])? $dataArray['fieldName']: null;
		$selectByText = isset($dataArray['selectByText'])? $dataArray['selectByText']:null;
		$selectByVal = isset($dataArray['selectByVal'])? $dataArray['selectByVal']:null;
		if($selectByVal){
		$selectByVal = explode(",",$selectByVal); // added by Maleeha Mafas 19/02/2014
		}
		$format = isset($dataArray['format'])? $dataArray['format']:null;
		$multiple = isset($dataArray['multiple'])? $dataArray['multiple']:false;
		$optionsOnly = isset($dataArray['optionsOnly'])? $dataArray['optionsOnly']:false;
		$label = isset($dataArray['label'])? $dataArray['label']:null;
        
		$display = isset($dataArray['display'])? explode(',',$dataArray['display']):null; //adding explode commend by NCW
		
        $required = isset($dataArray['required'])? $dataArray['required']:null;
        $groupBy = isset($dataArray['groupBy'])? $dataArray['groupBy']:null;     //added by Sachini Perera 24/07/2013
        $groupCodes = isset($dataArray['codename'])?$dataArray['codename']:null;     //added by Sachini Perera 24/07/2013
        
		//var_dump($selectByVal);
        //var_dump($groupCodes); //Sachinicodename
        //echo $groupCodes['2'];
      
        //var_dump($dataArray['data']['groupcodes']['group']); //Sachini
         //echo '<br>';
        //echo $groupCodes;
         
        //set display values
        //added by NCW
        $display_concat_value = ',';
        if(count($display)>1){ 
        	$display_concat_value = $display[0];
        	array_splice($display,0,1);
        }
        else
        	$display = $display[0];
			
        if(!empty($selectByText) && !empty($selectByVal)) $selectByText = null ; // Choos ByVal if both provided //WCD
        
		//var_dump($selectByText);
        //var_dump($display);	

       
		$previousValue = NULL;
            switch ($format) {
                
        
            case 'html':
                  
                            
    	   	
                    if (!is_array($pk)) $pk = explode(',', $pk);
                    $nrows = sizeof($dataset) ;
                    $mul = ($multiple)?'[]':'';
                    $size = ($multiple)?'5':'1';
					
                    if(!$optionsOnly) {  
                        
                        echo '<select size="'.$size.'"  id="'.$fieldName.'" name="'.$fieldName.$mul.'" label="'.$label.'" ';      
                        if($multiple) echo ' MULTIPLE ';
                        echo '>',"\n"; 
                        //if($groupBy)echo '<optgroup label="'.$groupBy.'">';

                    }//end if(options)
      		
                    if(empty($selectByText) && empty($selectByVal)){
                        
                        echo "\t",'<option value="" selected="selected" >Select.... </option>',"\n";
                        
                    }else{
                        
                        echo "\t",'<option value="" >Select.... </option>',"\n";
                    }		

                    $sbt = null;
                    for($ix=1;$ix<=$nrows;$ix++) {
        	
                       if($ix > 0) {
                           
                            /*
                             foreach($grp as $dat){
                            $grpdata = $dataset[$ix][$dat];
                           echo $grpdata;
                                    
                            }
                               
                              */
                              $val='';
                            //for composite keys construct the composit value with '_'
                            //suffix

                            foreach($pk as $key){
                                    $val .= $dataset[$ix][$key].'_';
                                    
                            }
                            

                            $val=trim($val,'_');
                            $selectedAttrib = null;
                            $foundText= false; $foundVal=false;

                            if(!empty($selectByText) || !empty($selectByVal) ){
                            	//change by NCW
                            	if(is_array($display)){
                            		foreach ($display as $key=>$value){
                            			//var_dump($display[$key]);
	                            		if(!empty($selectByText) && !empty($dataset[$ix][$display[$key]])){
	                                        //$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
	                                        $sbt = explode(',',$selectByText);
	                                        $foundText = in_array($dataset[$ix][$display[$key]],$sbt);
	
	                                    }else{ 
											$foundText = false;
	                                    }
                            		}
                            	}else{
									if(!empty($selectByText) && !empty($dataset[$ix][$display])){
									
									//$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
									$sbt = explode(',',$selectByText);
									$foundText = in_array($dataset[$ix][$display],$sbt);
									
									}else{ 
										$foundText = false;
									}

								}
                                    if(!empty($selectByVal) && !empty($val)){
											
                                            //$foundVal = strpos($selectByVal,$val) ; // commented by Maleeha Mafas
											$foundVal = in_array($val,$selectByVal) ; // added by Maleeha Mafas

                                    }else{ 

                                            $foundVal = false;
                                    }			

                          }//end if(!empty($selectByText)
//var_dump($foundText);
                            if($foundText !== false || $foundVal !== false ) {

                                    $selectedAttrib = 'selected="selected"';									
                          }
                          
                          if($groupBy){
                              $grp_val = formatString($dataset[$ix][$groupBy]);
                              $grp_code = $grp_val;
                              if($groupCodes){
                                  $flag = 0;
                                  foreach ($groupCodes as $k => $v) {
                                       switch($grp_val){
                                            case $k: 
                                                $grp_code = $v; 
                                                $flag = 1;
                                                break;     
                                    }
                                    if($flag == 1) break;
                                     
                                  }
                                   
                              }
                                 
                                 if ($previousValue == NULL ) {
                                        
                                        echo '<optgroup label="'.$grp_code.'">';
                                        
                                 }
                                 if ($previousValue != $grp_val && $previousValue!= null) {
                                        echo '</optgroup>';
                                        echo '<optgroup label="'.$grp_code.'">';
                                 }
                                
                          }
                          //creating html option tag for selection 
                          	//added by NCW
                          	if(is_array($display)){
                          		$display_value_array;
                          		foreach ($display as $key=>$value){
                          			if(isset($dataset[$ix][$value])){
                          				$display_value_array[$key] = $dataset[$ix][$value]; 
                          			}
                          		}
                          		$display_value = implode($display_concat_value,$display_value_array);
                          	}
                          	else{
                          		if(isset($dataset[$ix][$display])){
                          			$display_value = $dataset[$ix][$display]; 
                          		}
                          	}
                          	echo "\t",'<option value="'.$val.'" '.$selectedAttrib.' >'.$display_value.'</option>',"\n";
                          	
                          /*
                          if($fieldName == "ws_id"){
                          		if(isset($dataset[$ix]['full_name']) && !isset($groupBy)){
                          			$display_value=formatString($dataset[$ix]['full_name'])."-".formatString($dataset[$ix]['day']).":".formatString($dataset[$ix]['start_time'])."-".formatString($dataset[$ix]['end_time']);
                          		}elseif(isset($dataset[$ix]['full_name']) && isset($groupBy)){
                          			$display_value=formatString($dataset[$ix]['day']).":".formatString($dataset[$ix]['start_time'])."-".formatString($dataset[$ix]['end_time']);
                          		}elseif(isset($dataset[$ix]['day'])){
                          		$display_value=formatString($dataset[$ix]['day']).":".formatString($dataset[$ix]['start_time'])."-".formatString($dataset[$ix]['end_time']);
                          		}else{
                          		$display_value=formatString($dataset[$ix]['start_time'])."-".formatString($dataset[$ix]['end_time']);
                          		}
                          		echo "\t",'<option value="'.$val.'" '.$selectedAttrib.' >'.$display_value.'</option>',"\n";
                          	}else{
                          		
                          		$display_value=formatString($dataset[$ix][$display]);
                          		echo "\t",'<option value="'.$val.'" '.$selectedAttrib.' >'.$display_value.'</option>',"\n";
                          	}
   							*/
                             
                              if($groupBy){
                                   $previousValue = $grp_val;
                                   
                              }
			
                    }//end if(ix)
        
        
      		   
                    }//end for     

                    if(!$optionsOnly) {

                          if($groupBy)  echo '</optgroup>';
                          echo '</select>',"\n";
                    }
      
                      			
    break;
				
    case 'xml':
        	
        	
        	if (!is_array($pk)) $pk = explode(',', $pk);
        	
        	$nrows = sizeof($dataset);
        	
        	if($multiple) { $type='multiselect'; } else { $type='select';}
                if($required) { $validate='NotEmpty'; } 
        	 
        	               	
            if(!$optionsOnly) {
                        if($required) {
                        echo '<item type="'.$type.'" name="'.$fieldName.'" id="'.$fieldName.'" label="'.$label.'" validate="NotEmpty" required="true">';  
                        }else {    
        		echo '<item type="'.$type.'" name="'.$fieldName.'" id="'.$fieldName.'" label="'.$label.'">';     
                        }   	
        	}

        	if(empty($selectByVal)&& empty($selectByText)){
        		echo "\n\t",'<option value=""  selected="true"  label="Select...."  >Select....</option>';
        	}else{
        		echo "\n\t",'<option value="" label="Select...."  >Select....</option>';
        	}
        	
        	$sbt = null;
        	for($ix=1;$ix<=$nrows;$ix++){ 
        		
          	if($ix > 0)
          		{
          			$val='';
          			foreach($pk as $key){
          				$val .= $dataset[$ix][$key].'_';
          			}
          	
          			$val=trim($val,'_');        
          			
                  	$foundText= false; $foundVal=false;				
                  
                  	if(!empty($selectByVal)|| !empty($selectByText)){

                  		//change by NCW
						if(is_array($display)){
                        	foreach ($display as $key=>$value){
                            //var_dump($display[$key]);
	                        	if(!empty($selectByText) && !empty($dataset[$ix][$display[$key]])){
	                            	//$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
	                                $sbt = explode(',',$selectByText);
	                                $foundText = in_array($dataset[$ix][$display[$key]],$sbt);
								}else{ 
									$foundText = false;
	                           	}
                            }
						}else{
							if(!empty($selectByText) && !empty($dataset[$ix][$display])){
								
								//$foundText = strpos($selectByText,(string)$dataset[$ix][$display]);
								$sbt = explode(',',$selectByText);
								$foundText = in_array($dataset[$ix][$display],$sbt);
								
							}else{ 
								$foundText = false;
							}
						}
						
						
                  			
                  		if(!empty($selectByVal) && !empty($val)){
                  			//$foundVal = strpos($selectByVal,$val) ;
							$foundVal = in_array($val,$selectByVal) ;
                  		}else{
                  			$foundVal = false;
                  		}	
             
                  }//endif
                  
        	      if($foundText !== false || $foundVal !== false ) {
         		  		$selectedAttrib = 'selected="true"';
        		  }else{
        				$selectedAttrib = '';
        		  }        				
          		
        		  //creating option tag for selection 
                	//added by NCW
                	if(is_array($display)){
                		$display_value_array;
                	    foreach ($display as $key=>$value){
                	    	if(isset($dataset[$ix][$value])){
                	        	$display_value_array[$key] = $dataset[$ix][$value]; 
                	        }
						}
                	    $display_value = implode($display_concat_value,$display_value_array);
					}
                	else{
                		if(isset($dataset[$ix][$display])){
               		     	$display_value = $dataset[$ix][$display]; 
                	    }
					}
					echo "\n\t",'<option value="'.$val.'" '.$selectedAttrib.' label="'.$display_value.'" >'.$display_value.'</option>';
        			
          		}//end if(ix)
        		
        	}//end for
        	
            if(!$optionsOnly) {
        		echo "\n\t",'</item>';
            }
           	
         break;            
        case 'list':
            //to do
            break;
        
        case 'json':
            //todo
            break;          
            
   }//end switch case
   
}//end of dropdown();





/*###################################### Added by Dinishika ####################*/
function formatString($string) {
            
           $string = str_replace ( '&', '&amp;', $string );

           return $string;
}
/*###########################################################################*/


if ( ! function_exists('converDHTMLXGrid')) {
	  /**
	  * converDHTMLXGrid() function
	  *
	  * Prepares and echoes XML for DHTMLX Data Grid
	  *
	  * @param $data Data Array
	  *
	  * @param $sr Optional, Enable/Disable Smart Rendering, Boolean TRUE/FALSE,
	  *  Default false
	  *
	  * @param $start Optional, Start Position of data included in XML, Default 0
	  *
	  * @param $nnrows Optional, Number of data rows to included in XML, Default 20
	  *
	  * @param $includeHeaders   boolean, optional, use true to have headers included
	  *  in XML, otherwise keep it false
	  *
	  * @param $widths , array of column widths, optional (e.g. array(100,150,200); ) 
	  *
	  * @param $cellStyles , array of CSS styles, optiona (e.g. array('color:red;font-
	  * weight:bold;','color:#00ff00'); )
	  *
	  * @param $colList , array of columns to  display, optional (e.g. array('col1','col2','col3'); ) table column names  
	  * @return String, Grid XML
	  */
  function converDHTMLXGrid($data,$sr = false, $start=0,$nnrows=20,$includeHeaders=false,$widths='',$cellStyles='',$colList = false,$visibilityList='') {
    
    $widthStr = '';
    $widthArr = array();
    $rowStyleStr = '';
    $rowStylesArr = array();
    $sidx = 0;
    
  	// For debuging WCD
    //log_message('debug',"DATA ARRAY :- ".serialize($data));	 
    if(is_array($widths))
    {	
      /*foreach($widths as $w)
      {
      	$widthArr[] = $w;
      }	*/
      $widthArr = $widths ;		 
    }
    if(is_array($cellStyles))
    {	
    foreach($cellStyles as $rsty)
      {
      	$rowStylesArr[] = $rsty;
      }			 
    }
    $dataset = $data['dataset']['result_set'];
    $pk = explode(",",$data['dataset']['metadata']['PK']);
    //$headerList = getHeadersList($data['dataset']['metadata']);
    //$headers = explode(',',$headerList);
    $headers =array_slice($data['dataset']['metadata'],1);
    $nrows = sizeof($dataset);
    $nnrows = ($nrows < $nnrows)?$nrows:$nnrows;     
         
    //set header for XML Using DOM to do a clean job
    $doc = new DOMDocument('1.0', 'UTF-8');
    /*
    $doc->formatOutput = true;     //To produce output in a nice way
    
    header("Access-Control-Allow-Headers: X-Requested-With");
    if (stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
        header("Content-type: application/xhtml+xml"); 
    } else {
        header("Content-type: text/xml");
    }  */
    //Set Row data for XML
    $myrows = $doc->createElement("rows");
    //Following for smart rendering. Does not work with paging--
    if ($sr)   {
      $myrows->setAttribute('pos', $start);
      $myrows->setAttribute('rec_count', $nrows);
    }
    //Smart rendering End ---------------------------------------
	
    $doc->appendChild($myrows);
	
	if($data['dataset']['total_rows'] !=0){
    //Following needed for paging ------------------
    // Put Paging code here (Not needed for DHTMLX Enterprice version)
    //Paging End -----------------------------------
    
    //-----For column Headers---------
    $listCols = is_array($colList) ?  $colList :  $headers;
    if($includeHeaders)
    {  
        $myhead = $doc->createElement("head");
        $myrows->appendChild($myhead);
        $hix = 0;
  		foreach($headers as $key=>$h)
  		{
        if ($colList) {
          if (in_array($key,$colList)){
            $mycolumn = $doc->createElement("column");
            $mycolumn->setAttribute('type', 'ro');
            $mycolumn->setAttribute('align', 'center');
			
			//Following code to get the sorting type is added by Maleeha Mafas on Mar 14, 2014
			if($headers[$key]["type"] == "int" || $headers[$key]["type"] == "decimal"){
            	$sort_type= "int";
            
            }elseif($headers[$key]["type"] == "varchar" || $headers[$key]["type"] == "text" || $headers[$key]["type"] == "mediumtext" || $headers[$key]["type"] == "longtext"){
            	$sort_type= "str";
            
            }elseif($headers[$key]["type"] == "datetime" || $headers[$key]["type"] == "date"){
            	$sort_type= "date";
            
            }else{
				$sort_type=$headers[$key]["type"];
			}
            $mycolumn->setAttribute('sort', $sort_type);
			
            //$mycolumn->setAttribute('sort', 'str');
            //$mycolumn->setAttribute('width', getArrayElements($widthArr,$hix));
			
			if(!empty($visibilityList) && !$visibilityList[$key]){
			$mycolumn->setAttribute('hidden', 'true');
			}

            //TODO The following code should be modified to get the header width
            // as the minimum width if a width is not specified by user. WCD
            if (sizeof($widthArr)>0) { //User specified column widths are active
              $width=$widthArr[$key];
            }else{ //User not specified column widths so use header stuff
              if($h['width'] =="" || $h['width'] < "15"){
              	$width="50";
              
              }else{
              	$width=$h['width'];
              	
              }
            }
            $mycolumn->setAttribute('width', $width);
   		    $mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
            $myhead->appendChild($mycolumn);
            unset ($mycolumn);
            $hix++;
          }
        } else {
          $mycolumn = $doc->createElement("column");
          $mycolumn->setAttribute('type', 'ro');
          $mycolumn->setAttribute('align', 'center');
          //$mycolumn->setAttribute('sort', 'str');
		  
		  	//Following code to get the sorting type is added by Maleeha Mafas on Mar 14, 2014
			if($headers[$key]["type"] == "int" || $headers[$key]["type"] == "decimal"){
            	$sort_type= "int";
            
            }elseif($headers[$key]["type"] == "varchar" || $headers[$key]["type"] == "text" || $headers[$key]["type"] == "mediumtext" || $headers[$key]["type"] == "longtext"){
            	$sort_type= "str";
            
            }elseif($headers[$key]["type"] == "datetime" || $headers[$key]["type"] == "date"){
            	$sort_type= "date";
            
            }else{
				$sort_type=$headers[$key]["type"];
			}
            $mycolumn->setAttribute('sort', $sort_type);

          //$mycolumn->setAttribute('width', getArrayElements($widthArr,$hix));
		  
		  if(!empty($visibilityList) && !$visibilityList[$key]){
		  $mycolumn->setAttribute('hidden', 'true');
		  }

          //TODO The following code should be modified to get the header width
          // as the minimum width if a width is not specified by user. WCD
          if (sizeof($widthArr)>0) { //User specified column widths are active
            $width=$widthArr[$key];
          }else{ //User not specified column widths so use header stuff
            if($h['width'] =="" || $h['width'] < "15"){
            	$width="50";          
            }else{
            	$width=$h['width'];
            }
          }
          $mycolumn->setAttribute('width', $width);
  	      $mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
          $myhead->appendChild($mycolumn);
          unset ($mycolumn);
          $hix++;
        }
  		}
    } // End of Header construction
    
    //$pk_grid=join("_",$pk); 
    $datarowHTML = '';
    for($i=($start+1);$i<=($start+$nnrows);$i++)
    {
      $pk_grid="";
      unset($pk_g);
      foreach($pk as $col){
      	$pk_g[] = $dataset[$i][$col];
      
      }
      
      $pk_grid=join("_",$pk_g);
      unset($pk_g);
      //var_dump($dataset[$i]);
      $sidx = 0; 
      $myrow = $doc->createElement("row");
      //$myrow->setAttribute('id',$dataset[$i][$pk]);
      $myrow->setAttribute('id',$pk_grid);
      $myrows->appendChild($myrow);
      $si=0;
      foreach($dataset[$i] as $key=>$v)
      {
      	if(!(isset($v))){
      	 	$thisValue = '-';
      	}else {
      		$thisValue = $v;
        }
        if (is_array($colList)) {
          if (in_array($key,$colList)) {
            $mycell = $doc->createElement("cell");
            $mycell->setAttribute('style',getArrayElements($rowStylesArr,$si));
			$mycell->setAttribute('fieldName',$key);
            $mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
            $myrow->appendChild($mycell);
			$si++;
          }
        }else {
          $mycell = $doc->createElement("cell");
          $mycell->setAttribute('style',getArrayElements($rowStylesArr,$si));
		  $mycell->setAttribute('fieldName',$key);
          $mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
          $myrow->appendChild($mycell);
		  $si++;
        } 
        unset ($mycell,$thisValue);
        unset($pk_g);
        $pk_grid="";
		
      }
    	$sidx++;
      unset ($myrow);
      
    }
	}else{
	/////////////
	  $myrow = $doc->createElement("row");
      $myrow->setAttribute('id','0');
      $myrows->appendChild($myrow);
	  
	  $mycell = $doc->createElement("cell");
      $mycell->setAttribute('style','');
	  $mycell->setAttribute('fieldName','result');
      $mycell->appendChild($doc->createTextNode("")); 
      $myrow->appendChild($mycell);
		    
	  /*$mycell = $doc->createElement("cell");
      $mycell->setAttribute('style','');
	  $mycell->setAttribute('fieldName','result');
      $mycell->appendChild($doc->createTextNode("")); 
      $myrow->appendChild($mycell);*/


	  $mycell = $doc->createElement("cell");
      $mycell->setAttribute('style','');
	  $mycell->setAttribute('fieldName','result');
      $mycell->appendChild($doc->createTextNode('No Result Found!.')); 
      $myrow->appendChild($mycell);

	/////////////
	}
	$myXML=$doc->saveXML();
    //var_dump($myXML);
    return $myXML;
  }
} //-------------------End of  converDHTMLXGrid() -------------------

  /**
   * This function fetches the staff data from the xmlfeed and creates a 
   * session var with it. If the feched data is existing it just returns it
   * if not it will fetch the data from the server. This way it will only 
   * pull the data once per application
   * 
   * TODO Seee if performace can be improved by passing var by referance
   * 
   * RETURNS - $staff_xml session var which eeds to be converted to 
   *            simpleXml
   *            
   * Author : - Channa Dewamitta
   * Creaded on :- 16/08/2013
   * Last Modified by :-
   * Last modified on :-
   * Last Modification :-
   * 
   **/   
  function staff_object(){
  $cachestat='';
  $CI =&get_instance();
    //Load staff data
    if (! isset($_SESSION['staff_xml']) || ! $_SESSION['staff_xml']) {
    	$cachestat='';
      try{      	
      	$cachestat ='STAFF CACHE MISSED!- SESSION IS:-'.session_id();
        $_SESSION['staff_xml'] = get_content($CI->config->item('staff_feed_url').'staff/index/true/0/0/staff_xml_feed/XML/staff_id:full_name:time_difference?staff/status_equal=1');//_Change_        
      } catch (Exception $e){
        show_error('Sorry Could not connect to Server for Staff data!' );
      }
    }
    try{
    	$cachestat = ($cachestat =='')? 'STAFF CACHE HIT SUCCESS': $cachestat;
    	if(ENVIRONMENT != 'production') log_message('info',$cachestat);
        return new SimpleXMLElement($_SESSION['staff_xml']);        
      } catch (Exception $e){
        show_error('Sorry Could not connect to Server for Staff data!' );
      }
  
  }// End of staff_object ----------------

  
  /**
   * This function getts the data from a URL using CURL facility
   * 
   * @param string $url - the URL fro which the data to be feched
   * @param string $user - User ID if the URL needs authentication
   * @param string $pass - User password if the URL needs authentication
   * @param int $transfer - should CURL transfer the data direct. This same
   *                        effect is achieved with ob_start by the function
   *                        however the php way is to handle it through CURL
   *                        param. Both does not work.
   * 
   * RETURNS - $client_xml session var which eeds to be converted to 
   *            simpleXml
   *            
   * Author : - Channa Dewamitta
   * Creaded on :- 15/08/2013
   * Last Modified by :-
   * Last modified on :-
   * Last Modification :-
   * 
   **/ 
	function get_content($url,$user=null,$pass=null,$transfer=0)
  	{
      $ch = curl_init();
      
      curl_setopt ($ch, CURLOPT_URL, $url);
      curl_setopt ($ch, CURLOPT_HEADER, 0);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, $transfer);
      if($user){
        curl_setopt($ch, CURLOPT_USERPWD, "$user:$pass");  
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
      }
      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);   
      curl_setopt($ch, CURLOPT_COOKIESESSION, true);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); //Set to false here because ekwa.com certificate is invalid.WCD
  
      ob_start();
  
      curl_exec ($ch);
      curl_close ($ch);
      $string = ob_get_contents();
  
      ob_end_clean();
      
      return $string;     
  	}//End of get content 

  	
  	
if ( ! function_exists('converDHTMLXGridTree')) {
	  /**
	  * converDHTMLXGridTree() function
	  *
	  * Prepares and echoes XML for DHTMLX Data Grid
	  *
	  * @param $data Data Array
	  *
	  * @param $sr Optional, Enable/Disable Smart Rendering, Boolean TRUE/FALSE,
	  *  Default false
	  *
	  * @param $start Optional, Start Position of data included in XML, Default 0
	  *
	  * @param $nnrows Optional, Number of data rows to included in XML, Default 20
	  *
	  * @param $includeHeaders   boolean, optional, use true to have headers included
	  *  in XML, otherwise keep it false
	  *
	  * @param $widths , array of column widths, optional (e.g. array(100,150,200); ) 
	  *
	  * @param $cellStyles , array of CSS styles, optiona (e.g. array('color:red;font-
	  * weight:bold;','color:#00ff00'); )
	  *
	  * @param $colList , array of columns to  display, optional (e.g. array('col1','col2','col3'); ) table column names
	  * @param $title , name for inherit list (tree list title)
	  * @param $root , name for Root of grid tree.. root id is root
	  * 
	  * @return String, Grid XML
	  * 
	  */
  function converDHTMLXGridTree($data,$sr = false, $start=0,$nnrows=20,$includeHeaders=false, $widths='',$cellStyles='', $colList=false, $title='Hierarchy list', $root='Root') {

    $widthStr = '';
    $widthArr = array();
    $rowStyleStr = '';
    $rowStylesArr = array();
    $sidx = 0;
    
  	// For debuging WCD
    log_message('debug',"DATA ARRAY :- ".serialize($data));	 
    if(is_array($widths)) $widthArr = $widths ;
    
    if(is_array($cellStyles)){	
    	foreach($cellStyles as $rsty)
    		$rowStylesArr[] = $rsty;
    }
    
    $dataset = $data['dataset']['result_set'];
    $pk = array_unique(explode(",",$data['dataset']['metadata']['PK']));
    
    $headers =array_slice($data['dataset']['metadata'],1);
    $nrows = count($dataset);;
    $nnrows = ($nrows < $nnrows)?$nrows:$nnrows;
	
  	if (is_array($colList)) {
		$columnTitle = array_reverse(explode(",",array_shift($colList)));
		foreach($columnTitle as $columnId)
			array_unshift($colList,$columnId);
  	}
    
    //set header for XML Using DOM to do a clean job
    $doc = new DOMDocument('1.0', 'UTF-8');

    //Set Row data for XML
    $myrows = $doc->createElement("rows");
    //Following for smart rendering. Does not work with paging--
    if ($sr)   {
    	$myrows->setAttribute('parent',0);
    	$myrows->setAttribute('pos', $start);
    	$myrows->setAttribute('rec_count', $data['dataset']['total_rows']);
    }
    //Smart rendering End ---------------------------------------
	
    $doc->appendChild($myrows);
	
    if($data['dataset']['total_rows'] !=0){
    	//Following needed for paging ------------------
    	// Put Paging code here (Not needed for DHTMLX Enterprice version)
    	//Paging End -----------------------------------
    	
    	//-----For column Headers---------
    	//$listCols = is_array($colList) ?  $colList :  $headers;
    	if($includeHeaders){
	    	 
	        $myhead = $doc->createElement("head");
        	$myrows->appendChild($myhead);
        	$hix = 0;
        	
//********** Creating tree colum ************************************************************//
        	$mycolumn = $doc->createElement("column");
            $mycolumn->setAttribute('type','tree');
            $mycolumn->setAttribute('align', 'center');
            $mycolumn->setAttribute('sort', 'str');
            
            //setting Tree column width
            $mycolumn->setAttribute('width', (is_array($widthArr)?array_shift($widthArr):250));
   		    $mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$title.'</div>')); 
            $myhead->appendChild($mycolumn);
            unset ($mycolumn);
//*******************************************************************************************//
            
//********** creating column headers ********************************************************//
  			foreach($headers as $key=>$h)
  			{
        		if ($colList) {
          			if (in_array($key,$colList)){
            			$mycolumn = $doc->createElement("column");
            			$mycolumn->setAttribute('type', 'ro');
            			$mycolumn->setAttribute('align', 'center');
            			$mycolumn->setAttribute('sort', 'str');
            			if (sizeof($widthArr)>0) { //User specified column widths are active
              				$width=$widthArr[$key];
            			}
            			else{ //User not specified column widths so use header stuff
              				if($h['width'] =="" || $h['width'] < "15"){
              					$width="50";
              				}
              				else{
              					$width=$h['width'];
              				}
            			}
            			$mycolumn->setAttribute('width', $width);
   		    			$mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
            			$myhead->appendChild($mycolumn);
            			unset ($mycolumn);
            			$hix++;
          			}
        		}
        		else {
          			$mycolumn = $doc->createElement("column");
          			$mycolumn->setAttribute('type', 'ro');
          			$mycolumn->setAttribute('align', 'center');
          			$mycolumn->setAttribute('sort', 'str');
          			//$mycolumn->setAttribute('width', getArrayElements($widthArr,$hix));
          			//TODO The following code should be modified to get the header width
          			// as the minimum width if a width is not specified by user. WCD
          			if (sizeof($widthArr)>0) { //User specified column widths are active
            			$width=$widthArr[$key];
          			}
          			else{ //User not specified column widths so use header stuff
            			if($h['width'] =="" || $h['width'] < "15"){
            				$width="50";          
            			}
            			else{
            				$width=$h['width'];
            			}
          			}
          			$mycolumn->setAttribute('width', $width);
  	      			$mycolumn->appendChild($doc->createTextNode('<div style="text-align:center;">'.$h['header'].'</div>')); 
          			$myhead->appendChild($mycolumn);
          			unset ($mycolumn);
          			$hix++;
        		}
			}
    	} // End of Header construction
//*******************************************************************************************//
    
    	$datarowHTML = '';
    	
//********** creating root for gridtree ****************************************************//
		$rootmyrow = $doc->createElement("row");
		$rootmyrow->setAttribute('id','root');
		//$rootmyrow->setAttribute('parent',0);
		//$rootmyrow->setAttribute('selected',1);
      	$rootmyrow->setAttribute('open',0);
      	$myrows->appendChild($rootmyrow);
      		$rootcell = $doc->createElement("cell");
            $rootcell->appendChild($doc->createTextNode(stripslashes($root)));
            $rootcell->setAttribute('align', 'left');
        	$rootcell->setAttribute('width', 250); 
            $rootmyrow->appendChild($rootcell);
//*******************************************************************************************//
		    createRow($dataset,$pk,$doc,$rootmyrow,$rowStylesArr,$colList);
            
	}
	else{
	/////////////
	  $myrow = $doc->createElement("row");
      $myrow->setAttribute('id','0');
      $rootmyrow->appendChild($myrow);
	  $mycell = $doc->createElement("cell");
      $mycell->setAttribute('style','');
	  $mycell->setAttribute('fieldName','result');
      $mycell->appendChild($doc->createTextNode('No Result Found!.')); 
      $myrow->appendChild($mycell);
	/////////////
	}
	$myXML=$doc->saveXML();
    
    return $myXML;
  } //-------------------End of  converDHTMLXGridTree() -------------------

function createRow($dataset,$pk,$doc,$rootmyrow,$rowStylesArr,$colList){
//********** Creating gridtree *************************************************************//
		for($i=1;$i<=count($dataset);$i++){
      		$pk_grid="";
      		
      		//var_dump($pk);
      		foreach($pk as $col){
      			if(isset($dataset[$i][$col]))
      				$pk_grid[] = $dataset[$i][$col];
      		}
      		
      		$colListFilter = $colList;
      		for($ix=1; $ix<count($pk_grid); $ix++){
      			array_shift($colListFilter);
      		}
      		$pk_grid=join("_",$pk_grid);
      		
      		$myrow = $doc->createElement("row");
      		$myrow->setAttribute('id',$pk_grid);
      		$myrow->setAttribute('open',1);
      		$rootmyrow->appendChild($myrow);
      		reset($rowStylesArr);
      		
      		foreach($dataset[$i] as $key=>$value){
      			$thisValue = isset($value)?$value:'';
      			$thisValue = $thisValue;
      			
      			if (! is_array($value)) {
	        		if (is_array($colListFilter)) {
			      		//var_dump($colList);
	          			if (in_array($key,$colListFilter)){
	            			$mycell = $doc->createElement("cell");
	            			$mycell->setAttribute('style',current($rowStylesArr));
							$mycell->setAttribute('fieldName',$key);
	            			$mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
	            			$myrow->appendChild($mycell);
							next($rowStylesArr);
	          			}
	        		}
	        		else{
	          			$mycell = $doc->createElement("cell");
	          			$mycell->setAttribute('style',current($rowStylesArr));
			  			$mycell->setAttribute('fieldName',$key);
	          			$mycell->appendChild($doc->createTextNode(stripslashes($thisValue))); 
	          			$myrow->appendChild($mycell);
			  			next($rowStylesArr);
	        		}
        		}
        		else{
        			createRow($value,$pk,$doc,$myrow,$rowStylesArr,$colList);
        		}
        		unset($mycell,$thisValue);
      		}
      		unset ($myrow);
    	}
	}//-------------------End of  converDHTMLXGridTree() -------------------
	
	/**
	 * This function gets the contents of a file or stream while establishing the
	 * same session. Unlike "get_content()" function hich opens a ne session hen
	 * the file is accessed this preserves the surrent session. Especialy used to
	 * get contents from within CI in dropdowns and other pre-built componants.
	 *
	 *
	 * RETURNS - the content of the file as a string.
	 *
	 *
	 * Author : - Channa Dewamitta
	 * Creaded on :- 13/12/2013
	 * Last Modified by :-
	 * Last modified on :-
	 * Last Modification :-
	 *
	 **/
	function get_contents_with_session($url){
		 
		$opts = array( 'http'=>array( 'method'=>"GET",
				'header'=>"Accept-language: en\r\n" .
				"Cookie: ".session_name()."=".session_id()."\r\n" ) );
		$context = stream_context_create($opts);
		session_write_close();   // this is the key
		try {
			$contents = file_get_contents( $url, false, $context);
			return  $contents;
		}catch (Exception $e)  {
			show_error("Sorry! An error occoured while fetching data from server");
			return false;
		}
	} // End of get_contents_with_session
}
?>